
///////////////////////////////////////////////////////////////////////////////////////////////////////////
ArrayList<PVector> punkte1,punkte2,punkte3,punkte4;
float winkelG,winkelG1,winkelG2;
float a, b;
float d,h;
float K;
float[][] Ergebnis;
float Frequenzen[];
float Amplituden[];
float winkelBM = 0;
float winkelBM1= 0;
float winkelBM2= 0;
float farbton1, farbton2, farbton3;
float x, y, X, Y;
float u, v, U, V;
float q, r, Q, R;
float s, t, S, T;
float umdrehungen;
float delta;
float deltaLinie;
boolean wahlB,wahlC,wahlD,wahlE,wahlF,wahlG;
boolean wahlH,wahlI,wahl1,wahl2,wahl3;
boolean nurEineKurveZeichnen;
boolean stopp;
//für eigene Farbpalette
boolean bunt=true;//Farbpalette Variation Hue oder eigen
boolean hS = true; //Hintergrund schwarz
boolean hintergrundFestgelegt = false;
int abschnitte =64;
int grenze = abschnitte+1;
int N;//Anzahl Schritte
int N1,N2,N3,N4;
color[] farbAnker; 
color[] farben4096;
float h1,s1,b1;
float h2,b2;
float H; 
int tastenH = 50;
int anzahlT;
boolean[] tasteAktiv;
boolean tastenWechsel=true;
char[] tBeschriftung;
PFont font;

////////////////////////////////////////////////////////////////// 
void setup() {
  size(800, 800);
  background(0);//weil bunt=true zu Beginn 
  colorMode(HSB, 360);
  smooth();
  winkelG =0;//mehrere Kurven mit Strecken dazwischen
  winkelG1=0;//eine Kurve
  delta = 0.02;
  deltaLinie = 0.4;
  Ergebnis = new float[4][2];
  for(int i=0; i<4;i++){
    for(int j=0; j<2;j++){
       Ergebnis[i][j]=0;
    }   
  } 
  Frequenzen = new float[8];  
  Amplituden = new float[8];
  punkte1=new ArrayList<PVector>();
  punkte2=new ArrayList<PVector>();
  punkte3=new ArrayList<PVector>();
  punkte4=new ArrayList<PVector>();
  //Wahl für Frequenzen und Amplituden:
  zufaelligeFreqenzenUndAmplituden();
  K=1; //bestimmt die Frequenz der Modulation
  umdrehungen=1;
  winkelBM = radians(winkelG); 
  wahlG= true;
  wahlC= false;wahlD= false;wahlE=false;
  wahlF= false;wahlH=false;
  wahlI= false;wahlB= false;
  wahl1=wahl2=wahl3=false;
  nurEineKurveZeichnen = false; 
  stopp=true; 
  farbton1 = 0;
  farbton2 = 120;
  farbton3 = 240;
  //für eigene Farbpalette
  farbAnker = new color[grenze];//Initialsierung
   
  N= round(umdrehungen*360/delta);
  for(int i=0;i<grenze;i++){
     farbAnker[i] = color(0);
  }
  
  farben4096 = new color[4096];
  for(int i=0;i<4096;i++){
     farben4096[i] = color(0);
  }
  
  farbPaletteBestimmen();
  tastenEinstellungen();

}
//////////////////////////////////////////////////////////////////////////

void draw() {
  tastenZeichnen(); 
  if(hS==true && !hintergrundFestgelegt){
    background(0);
    hintergrundFestgelegt = true;
  }
  if(hS==false && !hintergrundFestgelegt){
    background(360);
    hintergrundFestgelegt = true;
  }
  if(!stopp){
  translate(width/2, height/2);
  rotate(-PI/2);
  if(punkte1.size() != 0)punkteLoeschen(punkte1);
  if(punkte2.size() != 0)punkteLoeschen(punkte2);
  if(punkte3.size() != 0)punkteLoeschen(punkte3);
  if(punkte4.size() != 0)punkteLoeschen(punkte4);
 
  zufaelligeFreqenzenUndAmplituden();
  
  //zwischen zwei Kurven:  Kurven1 und Kurven3 mit fest gewählten Amplituden und Frequenzen
  if(wahlB){  
     for(int i=0; i<N;i++){
         u=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
         v=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
         punkte1.add(new PVector(u,v)); 
         s=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],2)[0];
         t=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],2)[1];
         punkte3.add(new PVector(s,t)); 
         winkelG   = winkelG+delta; 
         winkelBM = radians(winkelG);
     }
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1]);
     for(int j=0; j<N;j++){ 
         if(bunt)stroke(farbton1,360,360,100);
         else stroke(farben4096[(int)farbton1],100);
         strokeWeight(3);
         point(punkte1.get(j).x,punkte1.get(j).y);
         point(punkte3.get(j).x,punkte3.get(j).y);
         strokeWeight(1);
         line(punkte1.get(j).x,punkte1.get(j).y,punkte3.get(j).x,punkte3.get(j).y);
         if(bunt)farbton1 = (farbton1 +1)%360;
         else farbton1 = (farbton1 +1)%4096;      
    }  
    stopp=true;
  }  
  //zwischen zwei verschiedenen Kurven1 /////////////////////////////////////////////////////////////
  if(wahlC ){
     for(int i=0; i<N;i++){
         q=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
         r=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
         punkte1.add(new PVector(q,r)); 
         Q=kurve1(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[0];
         R=kurve1(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[1];  
         punkte2.add(new PVector(Q,R)); 
         winkelG =winkelG+delta;  
         winkelBM = radians(winkelG);
     }
    for(int j=0; j<N;j++){ 
       if(bunt)stroke(farbton1,360,360,100);
       else stroke(farben4096[(int)farbton1],100);
       strokeWeight(3);
       point(punkte1.get(j).x,punkte1.get(j).y);
       point(punkte2.get(j).x,punkte2.get(j).y);
       strokeWeight(1);
       line(punkte1.get(j).x,punkte1.get(j).y,punkte2.get(j).x,punkte2.get(j).y);
       if(bunt)farbton1 = (farbton1 +1)%360;
       else farbton1 = (farbton1 +1)%4096;      
    }  
    stopp=true;
  }
  //zwischen zwei verschiedenen Kurven2 ////////////////////////////////////////////////////////
  if(wahlD){
     for(int i=0; i<N;i++){
         x=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
         y=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
         punkte1.add(new PVector(x,y)); 
         X=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[0];
         Y=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[1];
         punkte2.add(new PVector(X,Y)); 
         winkelG =winkelG+delta;  
         winkelBM = radians(winkelG);
     }
     for(int j=0; j<N;j++){ 
       if(bunt)stroke(farbton1,360,360,100);
       else stroke(farben4096[(int)farbton1],100);
       strokeWeight(3);
       point(punkte1.get(j).x,punkte1.get(j).y);
       point(punkte2.get(j).x,punkte2.get(j).y);
       strokeWeight(1);
       line(punkte1.get(j).x,punkte1.get(j).y,punkte2.get(j).x,punkte2.get(j).y);
       if(bunt)farbton1 = (farbton1 +1)%360;
       else farbton1 = (farbton1 +1)%4096;      
    }  
    stopp=true;
    
  }  
  //zwischen zwei verschiedenen Kurven3 //////////////////////////////////////////////////
  if(wahlE){
     for(int i=0; i<N;i++){
       s=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
       t=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
       punkte1.add(new PVector(s,t)); 
       S=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],1)[0];
       T=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],1)[1];
       punkte2.add(new PVector(S,T)); 
       winkelG =winkelG+delta;  
       winkelBM = radians(winkelG);
     }
     
    for(int j=0; j<N;j++){ 
       if(bunt)stroke(farbton1,360,360,100);
       else stroke(farben4096[(int)farbton1],100);
       strokeWeight(3);
       point(punkte1.get(j).x,punkte1.get(j).y);
       point(punkte2.get(j).x,punkte2.get(j).y);
       strokeWeight(1);
       line(punkte1.get(j).x,punkte1.get(j).y,punkte2.get(j).x,punkte2.get(j).y);
       if(bunt)farbton1 = (farbton1 +1)%360;
       else farbton1 = (farbton1 +1)%4096;      
    }  
    stopp=true;
  }
  //zwischen Kurven1, Kurven2 und Kurven3///////////////////////////////////////////////////////////////
  if(wahlF){
     for(int i=0; i<N;i++){
       u=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
       v=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
       punkte1.add(new PVector(u,v)); 
       U=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[0];
       V=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[1];
       punkte2.add(new PVector(U,V)); 
       X=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],1)[0];
       Y=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],1)[1];
       punkte3.add(new PVector(X,Y));
       winkelG =winkelG+delta;  
       winkelBM = radians(winkelG);
     }
    for(int j=0; j<N;j++){ 
       if(bunt)stroke(farbton1,360,360,50);
       else stroke(farben4096[(int)farbton1],50); 
       strokeWeight(3);
       point(punkte1.get(j).x,punkte1.get(j).y);
       point(punkte2.get(j).x,punkte2.get(j).y);
       point(punkte3.get(j).x,punkte3.get(j).y);
       strokeWeight(1);
       line(punkte1.get(j).x,punkte1.get(j).y,punkte2.get(j).x,punkte2.get(j).y);
       line(punkte2.get(j).x,punkte2.get(j).y,punkte3.get(j).x,punkte3.get(j).y);
       if(bunt)farbton1 = (farbton1 +1)%360;
       else farbton1 = (farbton1 +1)%4096;      
    }  
    stopp=true;
    
  }
   //zwischen vier verschiedenen Kurven1 /////////////////////////////////////////////////////////////
  if(wahlG ){
    for(int i=0; i<N;i++){
       u=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
       v=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
       punkte1.add(new PVector(u,v)); 
       U=kurve1(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[0];
       V=kurve1(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[1];
       punkte2.add(new PVector(U,V)); 
       X=kurve1(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],2)[0];
       Y=kurve1(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],2)[1];
       punkte3.add(new PVector(X,Y));
       x=kurve1(winkelBM,Amplituden[6],Amplituden[7],Frequenzen[6],Frequenzen[7],3)[0];
       y=kurve1(winkelBM,Amplituden[6],Amplituden[7],Frequenzen[6],Frequenzen[7],3)[1];
       punkte4.add(new PVector(x,y));
       winkelG =winkelG+delta;  
       winkelBM = radians(winkelG);
     }
     
    for(int j=0; j<N;j++){ 
       if(bunt)stroke(farbton1,360,360,50);
       else stroke(farben4096[(int)farbton1],50);
       strokeWeight(3);
       point(punkte1.get(j).x,punkte1.get(j).y);
       point(punkte2.get(j).x,punkte2.get(j).y);
       point(punkte3.get(j).x,punkte3.get(j).y);
       point(punkte3.get(j).x,punkte4.get(j).y);
       strokeWeight(1);
       line(punkte1.get(j).x,punkte1.get(j).y,punkte2.get(j).x,punkte2.get(j).y);
       line(punkte2.get(j).x,punkte2.get(j).y,punkte3.get(j).x,punkte3.get(j).y);
       line(punkte3.get(j).x,punkte3.get(j).y,punkte4.get(j).x,punkte4.get(j).y);
       line(punkte4.get(j).x,punkte4.get(j).y,punkte1.get(j).x,punkte1.get(j).y);
       if(bunt)farbton1 = (farbton1 +1)%360;
       else farbton1 = (farbton1 +1)%4096;      
    }  
    stopp=true;        
  }
   //zwischen vier verschiedenen Kurven2 /////////////////////////////////////////////////////////////
  if(wahlH ){   
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
       for(int i=0; i<N;i++){
       u=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
       v=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
       punkte1.add(new PVector(u,v)); 
       U=kurve1(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[0];
       V=kurve1(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[1];
       punkte2.add(new PVector(U,V)); 
       X=kurve1(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],2)[0];
       Y=kurve1(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],2)[1];
       punkte3.add(new PVector(X,Y));
       x=kurve1(winkelBM,Amplituden[6],Amplituden[7],Frequenzen[6],Frequenzen[7],3)[0];
       y=kurve1(winkelBM,Amplituden[6],Amplituden[7],Frequenzen[6],Frequenzen[7],3)[1];
       punkte4.add(new PVector(x,y));
       winkelG =winkelG+delta;  
       winkelBM = radians(winkelG);
     }
     
    for(int j=0; j<N;j++){ 
       if(bunt)stroke(farbton1,360,360,50);
       else stroke(farben4096[(int)farbton1],50);
       strokeWeight(3);
       point(punkte1.get(j).x,punkte1.get(j).y);
       point(punkte2.get(j).x,punkte2.get(j).y);
       point(punkte3.get(j).x,punkte3.get(j).y);
       point(punkte3.get(j).x,punkte4.get(j).y);
       strokeWeight(1);
       line(punkte1.get(j).x,punkte1.get(j).y,punkte2.get(j).x,punkte2.get(j).y);
       line(punkte2.get(j).x,punkte2.get(j).y,punkte3.get(j).x,punkte3.get(j).y);
       line(punkte3.get(j).x,punkte3.get(j).y,punkte4.get(j).x,punkte4.get(j).y);
       line(punkte1.get(j).x,punkte1.get(j).y,punkte4.get(j).x,punkte4.get(j).y);
       if(bunt)farbton1 = (farbton1 +1)%360;
       else farbton1 = (farbton1 +1)%4096;      
    }  
    stopp=true;         
  }
   //zwischen vier verschiedenen Kurven3 /////////////////////////////////////////////////////////////
  if(wahlI ){
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     for(int i=0; i<N;i++){
       u=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
       v=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
       punkte1.add(new PVector(u,v)); 
       U=kurve3(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[0];
       V=kurve3(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[1];
       punkte2.add(new PVector(U,V)); 
       X=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],2)[0];
       Y=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[4],Frequenzen[5],2)[1];
       punkte3.add(new PVector(X,Y));
       x=kurve3(winkelBM,Amplituden[6],Amplituden[7],Frequenzen[6],Frequenzen[7],3)[0];
       y=kurve3(winkelBM,Amplituden[6],Amplituden[7],Frequenzen[6],Frequenzen[7],3)[1];
       punkte4.add(new PVector(x,y));
       winkelG =winkelG+delta;  
       winkelBM = radians(winkelG);
     }
     
    for(int j=0; j<N;j++){ 
       if(bunt)stroke(farbton1,360,360,50);
       else stroke(farben4096[(int)farbton1],50);
       strokeWeight(5);
       point(punkte1.get(j).x,punkte1.get(j).y);
       point(punkte2.get(j).x,punkte2.get(j).y);
       point(punkte3.get(j).x,punkte3.get(j).y);
       point(punkte3.get(j).x,punkte4.get(j).y);
       strokeWeight(1);
       line(punkte1.get(j).x,punkte1.get(j).y,punkte2.get(j).x,punkte2.get(j).y);
       line(punkte2.get(j).x,punkte2.get(j).y,punkte3.get(j).x,punkte3.get(j).y);
       line(punkte3.get(j).x,punkte3.get(j).y,punkte4.get(j).x,punkte4.get(j).y);
       line(punkte1.get(j).x,punkte1.get(j).y,punkte4.get(j).x,punkte4.get(j).y);
       if(bunt)farbton1 = (farbton1 +1)%360;
       else farbton1 = (farbton1 +1)%4096;     
    }  
    stopp=true;         
  }
  if(wahl1){
     strokeWeight(4);
     if(bunt)stroke(farbton1,360,360,360);
     else stroke(farben4096[(int)farbton1],360); 
     u=kurve1(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve1(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     U=kurve1(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     V=kurve1(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     line(u,v,U,V);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
  }
  if(wahl2){    
     strokeWeight(4);
     if(bunt)stroke(farbton1,360,360,360);
     else stroke(farben4096[(int)farbton1],360);
     u=kurve2(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve2(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     U=kurve2(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     V=kurve2(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     line(u,v,U,V);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
  }
  if(wahl3){
     strokeWeight(4);
     if(bunt)stroke(farbton1,360,360,360);
     else stroke(farben4096[(int)farbton1],360);
     u=kurve3(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve3(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     U=kurve3(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     V=kurve3(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     line(u,v,U,V);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
  }
  
  if(!nurEineKurveZeichnen)winkelG =winkelG+delta;  
  else winkelG1=winkelG1+deltaLinie;
 
 if (winkelG >=umdrehungen*360 || winkelG1 >=umdrehungen*360) { 
    stopp= true;    
  }
 }//end of if(!stopp)
}//end of draw

//Kurve1
float[] kurve1(float winkel, float a, float b, float f1, float f2, int k){ 
    U = a*sin(f1*winkel);
    V = b*sin(f2*winkel);   
    Ergebnis[k][0] = U;Ergebnis[k][1] = V;
    return Ergebnis[k];
}
//Kurve2
float[] kurve2(float winkel, float a, float b, float f1, float f2, int k){
    X = cos(winkel*K)*a*sin(f1*winkel);
    Y = cos(winkel*K)*b*sin(f2*winkel);
    Ergebnis[k][0] = X;Ergebnis[k][1] = Y;
    return Ergebnis[k];
}
//Kurve3
float[] kurve3(float winkel,float a, float b,  float f1, float f2, int k){  
  S = 50*cos(f1*winkel) + 1.4*b*cos(100*f1*winkel/a);
  T = 50*sin(f2*winkel) - 1.4*b*sin(100*f2*winkel/a);
  Ergebnis[k][0] = S;Ergebnis[k][1] = T;
  return Ergebnis[k];
}
//////////////////////////////////////////////////////////////////////
void mousePressed() { 
  u=2;
  if(mouseY < height-tastenH){
     winkelG=0;
     winkelG1=0;
     winkelBM = 0; 
     hintergrundFestgelegt = false;
     zufaelligeFreqenzenUndAmplituden();   
     stopp =false;
  }else{
     int ort = int(mouseX/(tastenH));println(ort);
       if(tastenWechsel){
          for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
          tastenWechsel = false;
       }
       
      switch(ort){
                    
      case 0: //'B'  Flächen zwischen Kurven1 und Kurve3
         tasteAktiv[0]=true;
         //zufaelligeFreqenzenUndAmplituden();
         wahlB = true;
         wahlC=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
         hintergrundFestgelegt = false;
         nurEineKurveZeichnen=false;
         winkelG=0;
         winkelBM = 0; 
         stopp =false;
         println();
         println("Flächen zwischen Kurven1 und Kurve3");     
        
      break;
      
      case 1://'C'  Flächen zwischen zwei Kurven1
         tasteAktiv[1]=true;
         zufaelligeFreqenzenUndAmplituden();
         wahlC = true;
         wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
         hintergrundFestgelegt = false;    
         nurEineKurveZeichnen=false;
         winkelG=0;
         winkelBM = 0; 
         stopp =false;
         println();
         println("Flächen zwischen zwei Kurven1");     
      break;
      
      case 2://'D'  Flächen zwischen zwei modulierten Lissajous-Kurven
         tasteAktiv[2]=true;
         zufaelligeFreqenzenUndAmplituden();
         wahlD = true;
         wahlB=wahlC=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
         hintergrundFestgelegt = false;
         nurEineKurveZeichnen=false;
         winkelG=0;
         winkelBM = 0; 
         stopp =false;
         println();
         println("Flächen zwischen zwei modulierten Lissajous-Kurven");     
      break;
      
      case 3://'E' Flächen zwischen zwei beliebigen Kurven
         tasteAktiv[3]=true;
         zufaelligeFreqenzenUndAmplituden();
         wahlE = true;
         wahlB=wahlC=wahlD=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
         hintergrundFestgelegt = false;
         nurEineKurveZeichnen=false;
         winkelG=0;
         winkelBM = 0; 
         stopp =false;
         println();
         println("Flächen zwischen zwei beliebigen Kurven");     
      break;
      
      case 4://'F' Flächen zwischen Kurven1, Kurven2 und Kurven3
         tasteAktiv[4]=true;
         zufaelligeFreqenzenUndAmplituden();
         wahlF = true;
         wahlB=wahlC=wahlD=wahlE=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
         hintergrundFestgelegt = false;
         nurEineKurveZeichnen=false;
         winkelG=0;
         winkelBM = 0; 
         stopp =false;
         println();
         println("Flächen zwischen Kurven1, Kurven2 und Kurven3");     
      break;
      
      case 5://'G'   Flächen zwischen vier Kurven1
         tasteAktiv[5]=true;
         zufaelligeFreqenzenUndAmplituden();
         wahlG = true;
         wahlB=wahlC=wahlD=wahlE=wahlF=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
         hintergrundFestgelegt = false;
         nurEineKurveZeichnen=false;
         winkelG=0;
         winkelBM = 0; 
         stopp =false;
         println();
         println("Flächen zwischen vier Kurven1");     
      break;
      
     case 6://'H' Flächen zwischen vier Kurven2
         tasteAktiv[6]=true;
         zufaelligeFreqenzenUndAmplituden();
         wahlH = true;
         wahlB=wahlC=wahlD=wahlE=wahlF=wahlG=wahlI=wahl1=wahl2=wahl3=false; 
         hintergrundFestgelegt = false;
         nurEineKurveZeichnen=false;
         winkelG=0;
         winkelBM = 0; 
         stopp =false;
         println();
         println("Flächen zwischen vier Kurven2");       
      break;
      
    case 7://'I'  Flächen zwischen vier Kurven3
         tasteAktiv[7]=true;
         zufaelligeFreqenzenUndAmplituden();
         wahlI = true;
         wahlB=wahlC=wahlD=wahlE=wahlF=wahlG=wahlH=wahl1=wahl2=wahl3=false; 
         hintergrundFestgelegt = false;
         nurEineKurveZeichnen=false;
         winkelG=0;
         winkelBM = 0; 
         stopp =false;
         println();
         println("Flächen zwischen vier Kurven3");     
      break;
      
      case 8://'b'  Farbpalette ändern
         tasteAktiv[8]=true;
         winkelG=0;
         winkelG1=0;
         winkelBM = 0;  
         hintergrundFestgelegt = false;
         bunt = !bunt; 
         if(!bunt){
           farbPaletteBestimmen();
         }else {
           farbton1 = 0;
           farbton2 = 120;
           farbton3 = 240;
         }
         println();
         println("Farbpalette geändert!");
         farbton1 =0;
         stopp =false;         
      break;
      
    case 9://'p'   Hintergrund schwarz/weiß
         tasteAktiv[9]=true;
         if (hS == true) hS =false;
         else hS=true;
         hintergrundFestgelegt = false;
         winkelG=0;
         winkelG1=0;
         winkelBM = 0;  
         farbton1 = 0;    
         println();
         println("Wechsel Hintergrundfarbe schwarz/weiß!");
         farbton1 =0;
         farbton2 = 120;
         farbton3 = 240;
         stopp =false; 
      break;
      
     case 10://'s'   stopp/fortfahren
         tasteAktiv[10]=true;
         winkelG=0;
         winkelG1=0;
         winkelBM = 0;  
         hintergrundFestgelegt = false;
         umdrehungen=umdrehungen+0.5;
         stopp =false;
         println();
         println("Anzahl der Umdrehungen: "+umdrehungen);     
      break;
      
    
      
      default:
        background(200);
        println("Keine Aktion");
        break;
      }
  }
}
///////////////////////////////////////////////////////////////////////////////
void tastenZeichnen(){
  colorMode(RGB,256);
  stroke(0,0,100);
  tastenWechsel=true;
  fill(0,0,100);
  rect(width/2,height-tastenH/2,width,tastenH);
  for(int i=0; i<anzahlT; i++){
      if(tasteAktiv[i])fill(color(255,255,0));
      else fill(color(255));     
      rect(tastenH/2 + i*tastenH,height-tastenH/2,40,40);
      fill(0);
      text(tBeschriftung[i],tastenH/2-8 + i*tastenH,height-tastenH/2+8);  
      fill(255);
     // if(i<2)  text(int(Frequenzen[i]),width/2+130+i*tastenH ,height-tastenH/2+8);     
    
  }   
   colorMode(HSB,360);
}
/////////////////////////////////////////////////////////////////////////
void tastenEinstellungen(){
   rectMode(CENTER);
   font = createFont("Arial",20);
   textSize(24);  
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
   String s = "BCDEFGHIbwu";
   anzahlT = s.length();
   tasteAktiv = new boolean[anzahlT];
   tBeschriftung = new char[anzahlT];
   for(int i= 0; i<anzahlT; i++) tBeschriftung[i] = s.charAt(i);
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
}
/////////////////////////////////////////////////////////////////////////////
void keyPressed(){
  if(key=='B'){   
     wahlB = true;
     zufaelligeFreqenzenUndAmplituden();
     wahlC=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     stopp =false;
     println();
     println("Flächen zwischen Kurven1 und Kurve3");     
  }  
  if(key=='C'){   
     wahlC = true;
     wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;    
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     stopp =false;
     println();
     println("Flächen zwischen zwei Kurven1");     
  }
  if(key=='D'){   
     wahlD = true;
     wahlB=wahlC=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     stopp =false;
     println();
     println("Flächen zwischen zwei modulierten Lissajous-Kurven");     
  }
  if(key=='E'){   
     wahlE = true;
     wahlB=wahlC=wahlD=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     stopp =false;
     println();
     println("Flächen zwischen zwei beliebigen Kurven");     
  }
  if(key=='F'){   
     wahlF = true;
     wahlB=wahlC=wahlD=wahlE=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     stopp =false;
     println();
     println("Flächen zwischen Kurven1, Kurven2 und Kurven3");     
  }
  if(key=='G'){   
     wahlG = true;
     wahlB=wahlC=wahlD=wahlE=wahlF=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     stopp =false;
     println();
     println("Flächen zwischen vier Kurven1");     
  }
  if(key=='H'){   
     wahlH = true;
     wahlB=wahlC=wahlD=wahlE=wahlF=wahlG=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     stopp =false;
     println();
     println("Flächen zwischen vier Kurven2");     
  }
  if(key=='I'){   
     wahlI = true;
     wahlB=wahlC=wahlD=wahlE=wahlF=wahlG=wahlH=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     stopp =false;
     println();
     println("Flächen zwischen vier Kurven3");     
  }
  if(key=='1'){   
     wahl1 = true;
     wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;    
     nurEineKurveZeichnen=true;
     winkelG  =0;
     winkelG1 =0;
     winkelBM = 0; 
     winkelBM1= 0;
     nurEineKurveZeichnen=true;
     stopp =false;
     bunt = true; //sieht schöner aus!
     println();
     println("Lissajous-Kurve");     
  }
  if(key=='2'){   
     wahl2 = true;
     wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=true;
     winkelG  = 0;
     winkelG1 = 0;
     winkelBM = 0; 
     winkelBM1= 0;
     nurEineKurveZeichnen=true;
     stopp =false;
     bunt = true; 
     println();
     println("gedämpfte Lissajous-Kurve");     
  }
  if(key=='3'){   
     wahl3 = true;
     wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=true;
     winkelG  =0;
     winkelG1 = 0;
     winkelBM = 0; 
     winkelBM1= 0;
     nurEineKurveZeichnen=true;
     stopp =false;
     bunt = true; 
     println();
     println("trigonometrische Kurve");     
  }
  if(key=='u'){   
       winkelG=0;
       winkelG1=0;
       winkelBM = 0;  
       hintergrundFestgelegt = false;
       umdrehungen=umdrehungen+0.5;
       stopp =false;
       println();
       println("Anzahl der Umdrehungen: "+umdrehungen);     
  }
  if(key=='a'){   
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;   
    //alle Amplituden verkleinern
     for(int i=0;i<6;i++){
        Amplituden[i] =Amplituden[i]/1.2;         
     }
     println();
     println("Amplituden: ");  
     for(int i=0; i<6;i++){
       print(Amplituden[i]+"  ");
     }
     delta = delta*1.2;
     stopp =false;  
  }
  if(key=='A'){   
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;   
    //alle Amplituden vergrößern
     for(int i=0;i<6;i++){
        Amplituden[i] =Amplituden[i]*1.2;         
     }
     println();
     println("Amplituden: ");  
     for(int i=0; i<6;i++){
       print(Amplituden[i]+"  ");
     }
     delta = delta/1.2;
     stopp =false;  
  }
  if(key=='k'){   
     if(wahlD==true || wahlF==true || wahl2==true){
       wahlB=wahlC=wahlE=wahlG=false; 
       wahlH=wahlI=wahl1=wahl3=false; 
       if(K>0.11)K=K-0.1;
       hintergrundFestgelegt = false;
       winkelG=0;
       winkelG1=0;
       winkelBM = 0; 
       farbton1 =0;
       stopp =false;
       println();
       println("Lissajous-Kurven Modulation mit Frequenzfaktor K = "+K);     
     }else {
       println();
       println(" Hat bei dieser Wahl keinen Einfluss, da der Modulationsfaktor K nur auf Kurve2 wirkt!");
     }
  }
  if(key=='K'){   
     wahl2 = true;
     wahlB=wahlC=wahlE=wahlF=wahlG=false; 
     wahlH=wahlI=wahl1=wahlD=wahl3=false; 
     K=K+0.2;
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0; 
     farbton1 =0;
     stopp =false;
     println();
     println("Lissajous-Kurven Modulation mit Frequenzfaktor K = "+K);     
  }
 if(key=='Z'){ //doppelte Punktezahl  
     hintergrundFestgelegt = false;
     delta = delta/2;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;    
     stopp =false;
     println();
     println("Doppelte Punktezahl: Winkel-Delta: "+delta);       
  } 
  if(key=='z'){ //halbe Punktezahl  
     hintergrundFestgelegt = false;
     delta = delta*2;    
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;      
     stopp =false;
     println();
     println("Halbe Punktezahl: Winkel-Delta: "+delta);       
  } 
  if(key=='u'){            
     hintergrundFestgelegt = false;
     umdrehungen=umdrehungen+1;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0; 
     stopp =false;
     println();
     println("Anzahl der Umdrehungen: "+umdrehungen);     
  }
  if(key=='x'){  
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;  
     Frequenzen[0]=Frequenzen[0]+1;
     println();
     println("neue Frequenz 1: "+Frequenzen[0]+" alte Frequenzen: "+Frequenzen[1],Frequenzen[2],Frequenzen[3]); 
     stopp =false;
    
  }
  if(key=='y'){ 
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;     
     Frequenzen[1]=Frequenzen[1]+1;
     println();
     println("neue Frequenz 2: "+Frequenzen[1]+" alte Frequenzen: "+Frequenzen[0],Frequenzen[2],Frequenzen[3]);   
     stopp =false;
  }
 
  if(key=='b'){ 
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;  
     hintergrundFestgelegt = false;
     bunt = !bunt; 
     if(!bunt){
       farbPaletteBestimmen();
     }else {
       farbton1 = 0;
       farbton2 = 120;
       farbton3 = 240;
     }
     println();
     println("Farbpalette geändert!");
     farbton1 =0;
     stopp =false;
   }
  if(key=='p'){ 
     if (hS == true) hS =false;
     else hS=true;
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;  
     farbton1 = 0;    
     println();
     println("Wechsel Hintergrundfarbe schwarz/weiß!");
     farbton1 =0;
     farbton2 = 120;
     farbton3 = 240;
     stopp =false; 
  }
   
}
/////////////////////////////////////////////////////////////////////////////////////////////
void farbPaletteBestimmen(){
  h1=random(360);
  b1=random(360);
  s1=360;
  farbAnker[0] = color(h1,s1,b1);
 
  for(int j=1; j<grenze; j++){
      farbAnker[j] = farbeBestimmen( farbAnker[j-1]);  
  }
  for(int i=0; i<abschnitte; i++){
    zwischenFarbenBestimmen(i*abschnitte,farbAnker[i],farbAnker[i+1]);
  }
}
//für eigene Farbpalette
color farbeBestimmen(color f){
  color farbe = color(0);//Initialisierung
  h1=hue(f);
  h2=random(360);
  H = abs(h1-h2);
  b2=random(360);
  while(H>30){
    h2=random(360);
    H = abs(h1-h2);
  }
  farbe = color(h2,360,b2);
  return farbe;
}

void zwischenFarbenBestimmen(int k, color f1, color f2){
   int start = k;
   for(int i=start; i<64+start;i++){
      farben4096[i] = lerpColor(f1,f2,(float)(i-start)/64);
   }
}

void zufaelligeFreqenzenUndAmplituden(){
   for(int i=0;i<8;i++){
        Frequenzen[i] = round(random(2,23));
        //Benachbarte Frequenzenen werden verschieden gewählt
        if(i>0){
          while(Frequenzen[i] == Frequenzen[i-1]){
              Frequenzen[i] = round(random(2,23));
          }      
        }
    } 
    //Amplituden festlegen
    for(int i=0;i<6;i++){
        Amplituden[i] = round(random(200,300));
        //Benachbarte Amplitudenen müssen verschieden sein
        if(i>0){
          while(Amplituden[i] == Amplituden[i-1]){
              Amplituden[i] = round(random(200,300));
          }      
        }
     }
      println();
     println("Zufällige Wahl von Frequenzen und Amplituden");  
     println("Frequenzen: ");
     for(int i=0; i<8;i++){
       print(Frequenzen[i]+"  ");
     }
     println();
     println("Amplituden: ");
     for(int i=0; i<8;i++){
       print(Amplituden[i]+"  ");
     }
}

void punkteLoeschen(ArrayList<PVector>  punkte){
   int M = punkte.size();
   for(int i=M-1;i>=0;i--){
    punkte.remove(i);
  }
}
